; File Name   :	rdk-musmira.bin
; Format      :	Binary file
; Base Address:	0000h Range: 0000h - 0A60h Loaded length: 0A60h


; ein kleines Musikprogramm, das vierstimmig Musik ber den 
; eingebauten Piepser abspielt.
; 
; orig. RDK, an Z9001 adaptiert V. Pohlers 29.12.2013
; 
; Mit dem Kommando TON wird getestet, ob der Piepser aktiviert ist. Ist nichts zu 
; hren, muss man ein zweites Mal TON starten. Danach kann man mit MUSIK die Tne
; hren (nicht tonrein, aber immerhin!)


; Rahmenprogramm V.P.
;todo
;	Ausschalten der Systemuhr


		cpu	Z80

takt	equ	2457600/128
round	function x,int(x+0.5)


;-----------------------------------------------------------------------------
; Systemadressen, OS-Kommandorahmen
;-----------------------------------------------------------------------------

CTC0		equ	80h			; Kassette und Piepser
BPORT		equ	136			; Port f. Piepser

		org	300h
		jp	start
		db	"MUSIK   ",0
		jp	TON
		db	"TON     ",0
		db	0

;------------------------------------------------------------------------------
; MUSIK
;------------------------------------------------------------------------------

start:		call	tontest

		ld	de, aTitle
		ld	c, 9		; Zeichenkette ausgeben
		call	5
start0:		ld	c, 1		; Konsoleneingabe
		call	5
		and	5Fh 		; Klein->Gro
		cp	'J'
		jr	z, start1
		cp	'N'
		jp	nz, start0
		;Nein
		call	ton		;Ton init.

start1		ld	de, aMenu
		ld	c, 9		; Zeichenkette ausgeben
		call	5	
start2		ld	c, 1		; Konsoleneingabe
		call	5
		cp	'1'
		jr	z,startm1
		cp	'2'
		jr	z,startm2
		cp	'3'
		jr	z,startm3
		cp	'4'
		jr	z,startm4
		and	5Fh 		; Klein->Gro	
		cp	'E'
		jr	nz, start2
		;Ende
		xor	a
		ret			;zurck zum OS

startm1		ld	ix, musik1
startm		di
		call	melo1
		ei
		jr	start1

startm2		ld	ix, musik2
		jr	startm

startm3		ld	ix, musik3
		jr	startm

startm4		ld	ix, musik4
		jr	startm

aTitle:		db	0dh,0ah,"1-BIT-MUSIK nach RDK'83"
		db	0dh,0ah,"Volker Pohlers 12/2013"
		db	0dh,0ah,0ah
aTon:		db 	"War ein Ton zu hoeren J/N?",0
aMenu:		db	0dh,0ah,0ah,"Auswahl"
		db	0dh,0ah,"  1..INVENTION IN F J.S. BACH"
		db	0dh,0ah,"  2..MENUETT L.V. BEETHOVEN"
		db	0dh,0ah,"  3..TEST A3..A6"
		db	0dh,0ah,"  4..TEST DREIKLANG"
		db	0dh,0ah,"  E..Ende"
		db	0dh,0ah,0

;------------------------------------------------------------------------------
; TON
;------------------------------------------------------------------------------


; CTC genau einen Impuls erzeugen
; CTC 1 Flanke erzeugen

; ISR
ictc0:		ld	a,3
		out	(CTC0), a
		EI
		RETI

ton:		ld	de,(200h)
		ld	hl, ictc0
		ld	(200h), hl	; Interrupt-Routine
		ld	a,3
		out	(CTC0), a
		ld	a, 85h
		out	(CTC0), a
		ld	a, 1		; Zeitkonstante, 16 Takte
		out	(CTC0), a
		ld	a,(ix+0)	; 19 Takte Pause
		ld	(200h),de

; Tonausgabe ber PIO testen

tontest:	LD	BC,0A040H
		CALL	BEEP
		LD	BC,00A00H
		CALL	BEEP
		LD	BC,0A040H
		CALL	BEEP
;
		xor 	a
		ret

;Tonausgabe
;  C=Tonhoehe, B=Tondauer
;
BEEP:	PUSH	BC
BEEP1:	PUSH	BC
	LD	A,C
	OR	A
	LD	A,0
	JR	Z, BEEP2		;C=0 --> kein Ton
	LD	A,128			;Beep an
BEEP2:	OUT	(BPORT), A
	POP	BC
	PUSH	BC
BEEP3:	DEC	C
	JR	NZ, BEEP3		;Flanke abwarten
	LD	A,0
	OUT	(BPORT), A		;Beep aus
	POP	BC
	PUSH	BC
BEEP4:	DEC	C
	JR	NZ, BEEP4		;Flanke abwarten
	POP	BC
	DJNZ	BEEP1			;Tondauer
	POP	BC
	RET
;

	
;------------------------------------------------------------------------------
; 4stimmige Musikwiedergabe
; in: IX=Notenblatt
;------------------------------------------------------------------------------

;*************************************
; Musikprogramm	  mit  RAM-Speicher  *
; die Ausgabe erfolgt ueber IORQ     *
; Rolf-Dieter Klein 15.5.83          *
;*************************************

melo1:		ld	a, (ix+1)	; Note 1
		call	getadr
		ld	(note1), hl
		ld	a, (ix+2)
		call	getadr
		ld	(note2), hl
		ld	a, (ix+3)
		call	getadr
		ld	(note3), hl
		ld	a, (ix+4)
		call	getadr
		ld	(note4), hl
		; nun register definieren
		ld	hl, 0
		; ld	bc, 3906	; 1/8 sec 
		ld	bc, round(takt / 8 )
		
		ld	a, (ix+0)
lp11:		add	hl, bc
		dec	a
		jp	nz, lp11

		ld	c, l
		ld	b, h		; bc=Zaehler
		ld	hl, (note1)
		ld	de, (note2)
		exx
		ld	hl, (note3)
		ld	de, (note4)
		exx
		call	spiele
		inc	ix
		inc	ix
		inc	ix
		inc	ix
		inc	ix
		ld	a, (ix+0)	; weitere Musikdaten
		or	a
		jp	nz, melo1
;Ende
		ret

;-------------------------------------------------------
;	orig	out	(0), a		; Impuls geben

impuls	macro
	LD	A,128			;Beep an
	OUT	(BPORT), A
	XOR	A			;Beep aus
	OUT	(BPORT), A
	endm

spiele:
lp1:		dec	hl
		ld	a, h
		or	l
		jp	nz, s1
		ld	hl, (note1)
		impuls			; Impuls geben
s1:		dec	de
		ld	a, d
		or	e
		jp	nz, s2
		ld	de, (note2)
		impuls			; Impuls geben
s2:		exx
		dec	hl
		ld	a, h
		or	l
		jp	nz, s3
		ld	hl, (note3)
		impuls			; Impuls geben
s3:		dec	de
		ld	a,d
		or	e
		jp	nz, s4
		ld	de, (note4)
		impuls			; Impuls geben
s4:		exx
		dec	bc
		ld	a, b
		or	c
		jp	nz, lp1		; 32s bei 4MHz pro Durchlauf
		ret

getadr:					; holt Adresse Noten nach iy Temp
					; wert der Note nach hl
					; a=0 dann hl=ffff
		or	a
		jp	nz, gt1
		ld	hl, 0FFFFh
		ret

gt1:					; in a der Interncode 1..n
		dec	a		; bereich 0..n
		ld	e, a
		ld	d, 0		; d:=0 e:=a
		ld	iy, nottab	; Adresse Notentabelle
		add	iy, de		; Note direkt
		add	iy, de		; Adresse + 4*Index
		ld	l, (iy+0)
		ld	h, (iy+1)	; hl=Notenwert
		ret


;-------------------------------------------------------

	include	musik2.inc

;-------------------------------------------------------

musik1
	include	2prtfjsb.inc

	db 0,0,0,0,0	;Ende

musik2
	include	lvbmin.inc

	db 0,0,0,0,0	;Ende


musik3
	
	no	1,A3
	no	1,0,A4
	no	1,0,0,A5
	no	1,0,0,0,A6
	no	1,A4,A4,A4,A4

	db 0,0,0,0,0	;Ende

musik4
	no	4,C4
	no	4,E4
	no	4,G4
	no	2,C4,E4,G4

	db 0,0,0,0,0	;Ende


;-------------------------------------------------------

note1:		ds	2
note2:		ds	2
note3:		ds	2
note4:		ds	2

		end

